=== debian/changelog ===
evqueue-core (2.0-1build1) bionic; urgency=medium

  * No-change rebuild for libxerces soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 16 Nov 2017 11:58:51 +0000

evqueue-core (2.0-1) stretch; urgency=medium

  * Initial release (closes: #880973).

 -- Thibault KUMMER <bob@coldsource.net>  Wed, 17 Aug 2016 12:30:16 +0200
