## evqueue-core 2.1

=== debian/changelog ===
evqueue-core (2.1-1build5) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:50:00 +1100

evqueue-core (2.1-1build4) noble; urgency=medium

  * No-change rebuild against libxerces-c3.2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 17 Mar 2024 07:47:23 +0000

evqueue-core (2.1-1build3) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:13:32 +0100

evqueue-core (2.1-1build2) eoan; urgency=medium

  * No change rebuild for libmysqlclient21.

 -- Robie Basak <robie.basak@ubuntu.com>  Mon, 12 Aug 2019 12:01:15 +0000

evqueue-core (2.1-1) unstable; urgency=medium

  * Fix: run subjobs when loop has no iterations
  * Fix: segfault
  * Fix: restart rsyslog only if present (closes: #881596)
  * Added debconf translations (closes: #882654, #883290, #883302, #883822,
    #884171)

 -- Thibault KUMMER <bob@coldsource.net>  Thu, 08 Nov 2018 09:52:40 +0000

evqueue-core (2.0-1) unstable; urgency=medium

  * Initial release (closes: #880973).

 -- Thibault KUMMER <bob@coldsource.net>  Wed, 17 Aug 2016 12:30:16 +0200
