=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: evqueue-core
 Section: net
 Priority: optional
-Maintainer: Thibault KUMMER <bob@coldsource.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Thibault KUMMER <bob@coldsource.net>
 Build-Depends: debhelper (>= 10), cmake, libxerces-c-dev, libpcre3-dev, default-libmysqlclient-dev
 Standards-Version: 4.1.1
 Homepage: http://www.evqueue.net
